<?php
class Ameex_Insurance_Block_Adminhtml_Company_EditFormContainer_Edit_Tab_Form extends Mage_Adminhtml_Block_Widget_Form
{
	protected function _prepareForm()
	{
		$form = new Varien_Data_Form();
		$this->setForm($form);
		$fieldset = $form->addFieldset('insurancecompany_form', array('legend'=>Mage::helper('ameex_insurance')->__('Insurance Company Information')));
	 
		$model = Mage::registry('insurance_company');
		
		$fieldset->addField('name', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Company Name'),
			'required'  => true,
			'name'      => 'name',
		));

		$fieldset->addField('email', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('E-mail'),
			'required'  => true,
			'name'      => 'email',
			'class'		=> 'validate-email'
		));

		$fieldset->addField('orders_per_cycle', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Orders Per Cycle'),
			'name'      => 'orders_per_cycle',
			'class'		=> 'validate-zero-or-greater',
			'class'		=> 'validate-digits',
			'required'  => true,
		));

		$fieldset->addField('status', 'select', array(
			'label'     => Mage::helper('ameex_insurance')->__('Status'),
			'class'     => 'required-entry',
			'required'  => true,
			'name'      => 'status',
			'values' => Mage::getModel('ameex_insurance/options')->getEnableDisable(),
        ));
		
	 	if(!is_null($model))
			$form->setValues($model->getData());
			
		return parent::_prepareForm();
	}
}
