<?php
$installer = $this;
 
$installer->startSetup();
 
$table = $installer->getConnection()
    ->newTable($installer->getTable('ameex_insurance/companies'))
    ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'identity'  => true,
        'unsigned'  => true,
        'nullable'  => false,
        'primary'   => true,
        'auto_increment' => true,
        ), 'Id')
    ->addColumn('name', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'Insurance Name')
    ->addColumn('email', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'E-mail')
    ->addColumn('status', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(), 'E-mail')
    ->addColumn('orders_per_cycle', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'nullable'  => false,
        'unsigned'  => true,
        ), 'Orders Per Cycle')
    ->addColumn('orders_assigned_in_this_cycle', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'nullable'  => false,
        'unsigned'  => true,
        'default'	=> 0,
        ), 'Orders Assigned In This Cycle')
    ->addColumn('to_be_assigned', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'nullable'  => false,
        'unsigned'  => true,
        'default'	=> 0,
        ), 'To Be Assigned')
	->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
        'nullable'  => false,
        'default'	=> Varien_Db_Ddl_Table::TIMESTAMP_INIT,
        ), 'Created At');
$installer->getConnection()->createTable($table);

$table = $installer->getConnection()
    ->newTable($installer->getTable('ameex_insurance/company_order_items'))
    ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'identity'  => true,
        'unsigned'  => true,
        'nullable'  => false,
        'primary'   => true,
        'auto_increment' => true,
        ), 'Id')
    ->addColumn('company_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'nullable'  => false,
        ), 'Company Id')
    ->addColumn('order_item_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'nullable'  => false,
        ), 'Order Item Id')
	->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
        'nullable'  => false,
        'default'	=> Varien_Db_Ddl_Table::TIMESTAMP_INIT,
        ), 'Created At')
	->addForeignKey(
        $installer->getFkName(
            'ameex_insurance/company_order_items',
            'company_id',
            'ameex_insurance/companies',
            'id'
        ),
        'company_id', $installer->getTable('ameex_insurance/companies'), 'id',
        Varien_Db_Ddl_Table::ACTION_CASCADE, Varien_Db_Ddl_Table::ACTION_CASCADE)
	->addForeignKey(
        $installer->getFkName(
            'ameex_insurance/company_order_items',
            'order_item_id',
            'sales/order_item',
            'item_id'
        ),
        'order_item_id', $installer->getTable('sales/order_item'), 'item_id',
        Varien_Db_Ddl_Table::ACTION_CASCADE, Varien_Db_Ddl_Table::ACTION_CASCADE);
    
$installer->getConnection()->createTable($table);

$table = $installer->getConnection()
    ->newTable($installer->getTable('ameex_insurance/activation_details'))
    ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'identity'  => true,
        'unsigned'  => true,
        'nullable'  => false,
        'primary'   => true,
        'auto_increment' => true,
        ), 'Id')
    ->addColumn('first_name', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'First Name')
    ->addColumn('last_name', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Last Name')
    ->addColumn('email', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'E-mail')
    ->addColumn('phone', Varien_Db_Ddl_Table::TYPE_BIGINT, null, array(
        'nullable'  => false,
        'unsigned'  => true,
        ), 'Phone')
	->addColumn('address1', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'Address1')
	->addColumn('address2', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Address2')
	->addColumn('city', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'City')
	->addColumn('state', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'State')
	->addColumn('zipcode', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Zip Code')
	->addColumn('country', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Country')
	->addColumn('imei', Varien_Db_Ddl_Table::TYPE_TEXT, null, array(), 'IMEI')
	->addColumn('manufacturer', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Manufacturer')
	->addColumn('phone_model', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Phone Model')
	->addColumn('cell_phone', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Cell Phone')
	->addColumn('activation_code', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'Activation Code')
	->addColumn('carrier', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Carrier')
	->addColumn('insurance_company_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'nullable'  => false,
        ), 'Insurance Company ID')
	->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
        'nullable'  => false,
        'default'   => Varien_Db_Ddl_Table::TIMESTAMP_INIT,
        ), 'Created At')
    ->addColumn('activated_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(), 'Activated At')
	->addForeignKey(
        $installer->getFkName(
            'ameex_insurance/activation_details',
            'insurance_company_id',
            'ameex_insurance/companies',
            'id'
        ),
        'insurance_company_id', $installer->getTable('ameex_insurance/companies'), 'id',
        Varien_Db_Ddl_Table::ACTION_CASCADE, Varien_Db_Ddl_Table::ACTION_CASCADE);
$installer->getConnection()->createTable($table);

$table = $installer->getConnection()
    ->newTable($installer->getTable('ameex_insurance/claim_details'))
    ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
        'identity'  => true,
        'unsigned'  => true,
        'nullable'  => false,
        'primary'   => true,
        'auto_increment' => true,
        ), 'Id')
    ->addColumn('first_name', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
    	'nullable'  => false,
    	), 'First Name')
    ->addColumn('last_name', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
    	'nullable'  => false,
    	), 'Last Name')
    ->addColumn('email', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'E-mail')
    ->addColumn('device_number', Varien_Db_Ddl_Table::TYPE_TEXT, null, array(
        'nullable'  => false,
        ), 'Device Number')
    ->addColumn('primary_phone', Varien_Db_Ddl_Table::TYPE_BIGINT, null, array(
        'nullable'  => false,
        'unsigned'  => true,
        ), 'Primary Phone')
    ->addColumn('alternate_phone', Varien_Db_Ddl_Table::TYPE_BIGINT, null, array(
        'unsigned'  => true,
        ), 'Alternate Phone')
	->addColumn('address1', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'Address1')
	->addColumn('address2', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Address2')
	->addColumn('city', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'City')
	->addColumn('state', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'State')
	->addColumn('zipcode', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Zip Code')
	->addColumn('country', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(), 'Country')
	// ->addColumn('policy_number', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
	// 	'nullable'  => false,
	// 	), 'Policy Number')
	->addColumn('damaged_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(), 'Damaged At')
	->addColumn('damage_type', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
		'nullable'  => false,
		), 'Damage Type')
	->addColumn('device_work', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
		'nullable'  => false,
		), 'Device Work')
	->addColumn('description', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
		'nullable'  => false,
		), 'Description')
    ->addColumn('amount_paid', Varien_Db_Ddl_Table::TYPE_DECIMAL, '10,2' , array(
        'nullable'  => false,
        ), 'Amount Paid')
    ->addColumn('agree_additional_charge', Varien_Db_Ddl_Table::TYPE_VARCHAR, null, array(
        'nullable'  => false,
        ), 'Agree Additional Charge')
	->addColumn('claimed_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
        'nullable'  => false,
        'default'   => Varien_Db_Ddl_Table::TIMESTAMP_INIT,
        ), 'Claimed At');
$installer->getConnection()->createTable($table);

$installer->addAttribute('catalog_product', 'insurance_company', array(
    'label'                    => 'Insurance Company',
    'group'                    => 'General',
    'input'                    => 'select',
    'required'                 => false,
    'source'                   => 'ameex_insurance/source_group',
    'backend'                  => 'ameex_insurance/backend_group',
    'global'                   => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
    'used_in_product_listing'  => false,
));

$installer->endSetup();
