<?php
class Ameex_Insurance_Block_Adminhtml_Retailers_EditFormContainer_Edit_Tab_Form extends Mage_Adminhtml_Block_Widget_Form
{
	protected function _prepareForm()
	{
		$form = new Varien_Data_Form();
		$this->setForm($form);
		$fieldset = $form->addFieldset('retailer_form', array('legend'=>Mage::helper('ameex_insurance')->__('Retailer Information')));
	 
		$model = Mage::registry('insurance_retailers');
		
		$fieldset->addField('retailer_name', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Retailer Name'),
			'required'  => true,
			'name'      => 'retailer_name',
		));

		$fieldset->addField('retailer_email', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Retailer E-mail'),
			'required'  => true,
			'name'      => 'retailer_email',
			'class'		=> 'validate-email'
		));
		$fieldset->addField('retailer_website', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Retailer Website'),
			'required'  => true,
			'name'      => 'retailer_website',
			
		));                

		$fieldset->addField('retailer_code', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Retailer Code'),
			'name'      => 'retailer_code',
			'required'  => true,
		));

		$fieldset->addField('status', 'select', array(
			'label'     => Mage::helper('ameex_insurance')->__('Retailer Status'),
			'class'     => 'required-entry',
			'required'  => true,
			'name'      => 'status',
			'values' => Mage::getModel('ameex_insurance/options')->getEnableDisable(),
        ));
		
	 	if(!is_null($model))
			$form->setValues($model->getData());
			
		return parent::_prepareForm();
	}
}
