<?php

class Limex_Advd_Block_Adminhtml_Dashboard extends Mage_Adminhtml_Block_Template
{
    protected $_storeSwitcher = null;

    protected function _prepareLayout()
    {
        $this->setTemplate('mst_advd/dashboard.phtml');

        $this->_initStoreSwitcher();

        return parent::_prepareLayout();
    }

    protected function _initStoreSwitcher()
    {
        $this->_storeSwitcher = Mage::app()->getLayout()->createBlock('adminhtml/store_switcher')
            ->setTemplate('mst_advd/store_switcher.phtml')
            ->setStoreVarName('store_ids');

        return $this;
    }

    public function getStoreSwitcher()
    {
        return $this->_storeSwitcher;
    }

    public function getDashboard()
    {
        return Mage::registry('current_dashboard');
    }

    public function getNotificationEditUrl()
    {
        $notification = Mage::getSingleton('advd/notification')->loadForCurrentUser();

        return Mage::helper('adminhtml')->getUrl('advdadmin/adminhtml_notification/edit',
                array('id' => $notification->getId()));
    }
}