<?php

class Limex_Advd_Block_Adminhtml_Widget_Search_Grid
    extends Limex_Advd_Block_Adminhtml_Widget_Abstract_Grid
{
    public function getGroup()
    {
        return 'Search';
    }

    public function getName()
    {
        return 'Last Search Terms';
    }

    public function prepareOptions()
    {
        $this->_form->addField('limit', 'text', array(
                'name'      => 'limit',
                'label'     => Mage::helper('advr')->__('Number Of Search Terms'),
                'value'     => $this->getParam('limit', 5)
            )
        );

        return $this;
    }

    protected function _prepareCollection($grid)
    {
        $collection = Mage::getModel('catalogsearch/query')
            ->getResourceCollection();
        $collection->setRecentQueryFilter();

        $grid->setCollection($collection);

        return $this;
    }

    protected function _prepareColumns($grid)
    {
        $grid->addColumn('search_query', array(
            'header'    => Mage::helper('advr')->__('Search Term'),
            'sortable'  => false,
            'index'     => 'query_text',
            'renderer'  => 'adminhtml/dashboard_searches_renderer_searchquery',
        ));

        $grid->addColumn('num_results', array(
            'header'    => Mage::helper('advr')->__('Results'),
            'sortable'  => false,
            'index'     => 'num_results',
            'type'      => 'number'
        ));

        $grid->addColumn('popularity', array(
            'header'    => Mage::helper('advr')->__('Number of Uses'),
            'sortable'  => false,
            'index'     => 'popularity',
            'type'      => 'number'
        ));

        $grid->setFilterVisibility(false);
        $grid->setPagerVisibility(false);
        $grid->setDefaultLimit($this->getParam('limit', 5));

        return $this;
    }

    public function getRowUrl($row)
    {
        return $this->getUrl('adminhtml/catalog_search/edit', array('id' => $row->getId()));
    }
}