<?php
 


class Limex_Advr_Block_Adminhtml_Order_ShippingMethod extends Limex_Advr_Block_Adminhtml_Order_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();

        $this->setHeaderText(Mage::helper('advr')->__('Sales By Shipping Method'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('pie');

        $this->_initChart()
            ->setNameField('shipping_method')
            ->setValueField('sum_grand_total')
        ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('sum_grand_total')
            ->setDefaultDir('desc')
            ->setDefaultLimit(100)
            ->setPagerVisibility(false)
        ;

        return $this;
    }

    public function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('sales/order')
            ->setFilterData($this->getFilterData())
            ->selectColumns($this->getVisibleColumns())
            ->groupByColumn('shipping_method')
        ;

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'shipping_method' => array(
                'header'               => 'Shipping Method',
                'type'                 => 'text',
                'frame_callback'       => array(Mage::helper('advr/callback'), 'shippingMethod'),
                'totals_label'         => 'Total',
                'filter_totals_label'  => 'Subtotal',
                'filter'               => false,
            ),
        );

        $columns += $this->getOrderTableColumns(true);

        return $columns;
    }
}