<?php

class Magegiant_Affiliatecampaign_Adminhtml_ProgramController extends Mage_Adminhtml_Controller_Action
{
	protected function _initAction() {
		$this->loadLayout()
			->_setActiveMenu('affiliate/program')
			->_addBreadcrumb(Mage::helper('adminhtml')->__('Campaigns Manager'), Mage::helper('adminhtml')->__('Campaign Manager'));
		return $this;
	}
 
	public function indexAction(){

		$this->_title($this->__('Affiliate'))->_title($this->__('Manage Campaigns'));
		$this->_initAction()
			->renderLayout();
	}
	
	public function gridAction(){

		$this->getResponse()->setBody($this->getLayout()->createBlock('affiliatecampaign/adminhtml_program_grid')->toHtml());
	}

	public function editAction(){

        $this->_initCategories();
		$id     = $this->getRequest()->getParam('id');
		$model  = Mage::getModel('affiliatecampaign/program');
		if ($storeId = $this->getRequest()->getParam('store',0))
			$model->setStoreId($storeId);
		$model->load($id);

		if ($model->getId() || $id == 0){
			$data = Mage::getSingleton('adminhtml/session')->getFormData(true);
			if (!empty($data)){
				$model->setData($data);
			}
			
			$this->_title($this->__('Affiliate'))->_title($this->__('Manage Programs'));
			if ($model && $model->getId())
				$this->_title($model->getName());
			else 
				$this->_title($this->__('New Campaign'));

			$model->getConditions()->setJsFormObject('affiliatecampaign_conditions_fieldset');
			$model->getActions()->setJsFormObject('affiliatecampaign_actions_fieldset');
			Mage::register('affiliatecampaign_data', $model);

			$this->loadLayout();
			$this->_setActiveMenu('affiliate/program');

			$this->_addBreadcrumb(Mage::helper('adminhtml')->__('Campaign Manager'), Mage::helper('adminhtml')->__('Campaign Manager'));
			$this->_addBreadcrumb(Mage::helper('adminhtml')->__('Campaign News'), Mage::helper('adminhtml')->__('Campaign News'));

			$this->getLayout()->getBlock('head')
				->setCanLoadExtJs(true)
				->setCanLoadRulesJs(true);

			$this->_addContent($this->getLayout()->createBlock('affiliatecampaign/adminhtml_program_edit'))
				->_addLeft($this->getLayout()->createBlock('affiliatecampaign/adminhtml_program_edit_tabs'));

			$this->renderLayout();
		} else {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('affiliatecampaign')->__('Campaign does not exist'));
			$this->_redirect('*/*/');
		}
	}
 
	public function newAction(){

        $this->editAction();


		// $this->_forward('edit');
	}
	
	public function transactionAction(){

		$this->loadLayout();
		$this->renderLayout();
	}
	
	public function transactionGridAction(){

		$this->loadLayout();
		$this->renderLayout();
	}
	
	public function accountAction(){

		$this->loadLayout();
		$this->getLayout()->getBlock('program.edit.tab.account')
			->setAccounts($this->getRequest()->getPost('oaccount',null));
		$this->renderLayout();
	}
	
	public function accountGridAction(){

		$this->loadLayout();
		$this->getLayout()->getBlock('program.edit.tab.account')
			->setAccounts($this->getRequest()->getPost('oaccount',null));
		$this->renderLayout();
	}
	
	protected function _initCategories(){
		if (!Mage::registry('program_categories'))
		if ($programId = $this->getRequest()->getParam('id')){
			$categoryCollection = Mage::getResourceModel('affiliatecampaign/category_collection')
				->addFieldToFilter('program_id',$programId);
			if ($storeId = $this->getRequest()->getParam('store',0))
				$categoryCollection->addFieldToFilter('store_id',$storeId);
			$categories = array();
			foreach ($categoryCollection as $category)
				$categories[] = $category->getCategoryId();
			Mage::register('program_categories',$categories);
		}
	}
	
	public function categoriesAction(){

		$this->_initCategories();
		$this->getResponse()->setBody(
            $this->getLayout()->createBlock('affiliatecampaign/adminhtml_program_edit_tab_categories')->toHtml()
        );
	}
	
	public function categoriesJsonAction(){

		$this->_initCategories();
		$this->getResponse()->setBody(
            $this->getLayout()->createBlock('affiliatecampaign/adminhtml_program_edit_tab_categories')
                ->getCategoryChildrenJson($this->getRequest()->getParam('category'))
        );
	}
	
	public function productAction(){

		$this->loadLayout();
		$this->getLayout()->getBlock('program.edit.tab.product')
			->setProducts($this->getRequest()->getPost('oproduct',null));
		$this->renderLayout();
	}
	
	public function productGridAction(){

		$this->loadLayout();
		$this->getLayout()->getBlock('program.edit.tab.product')
			->setProducts($this->getRequest()->getPost('oproduct',null));
		$this->renderLayout();
	}
 
	public function saveAction(){

		if ($data = $this->getRequest()->getPost()) {
			$data = $this->_filterDates($data, array('valid_from', 'valid_to'));
			if (isset($data['valid_from']) && $data['valid_from'] == '') $data['valid_from'] = null;
			if (isset($data['valid_to']) && $data['valid_to'] == '') $data['valid_to'] = null;
			$model = Mage::getModel('affiliatecampaign/program');
			
			if (isset($data['rule'])){
				$rules = $data['rule'];
				if (isset($rules['conditions']))
					$data['conditions'] = $rules['conditions'];
				if (isset($rules['actions']))
					$data['actions'] = $rules['actions'];
				unset($data['rule']);
			}
			
			// repair data
			if (isset($data['program_name']))
				$data['name'] = $data['program_name'];
			if (isset($data['customer_groups']) && is_array($data['customer_groups']))
				$data['customer_groups'] = implode(',',$data['customer_groups']);
			
			// add data to model
			if ($storeId = $this->getRequest()->getParam('store',0))
				$model->setStoreId($storeId);
			$model->load($this->getRequest()->getParam('id'));
			foreach ($model->getStoreAttributes() as $attribute)
				$model->setData($attribute.'_default',false);
			$model->addData($data)
				->setId($this->getRequest()->getParam('id'));
			
			try {
				$model->loadPost($data);
				if ($model->getActionsSerialized() != serialize($model->getActions()->asArray()))
					$model->setData('is_process',0);
				if ($model->getCreatedDate() == NULL)
					$model->setCreatedDate(now(true));
				
				// calculate number of affiliate account
                if (isset($data['program_account']) && is_string($data['program_account'])) {
					$programAccount = array();
					parse_str($data['program_account'],$programAccount);
					$programAccount = array_unique(array_keys($programAccount));
				}
				if (isset($data['autojoin']) && $data['autojoin'] && isset($data['scope']) && $data['scope'] == Magegiant_Affiliatecampaign_Model_Scope::SCOPE_GLOBAL ){
                    $collections = Mage::getResourceModel('affiliate/account_collection');
                    if ($model->getId()) {
                        $collections->getSelect()
                            ->joinLeft(array('j' => $collections->getTable('affiliatecampaign/joined')),
                                'main_table.account_id = j.account_id AND j.program_id = ' . $model->getId(),
                                array()
                            )->where('j.id IS NULL');
                    }
					$data['program_account'] = $collections->getAllIds();
				}elseif (isset($data['autojoin']) && $data['autojoin'] && isset($data['scope']) && $data['scope'] == Magegiant_Affiliatecampaign_Model_Scope::SCOPE_GROUPS ){
					if ($model->getData('customer_groups')){
						$customerGroups = explode(',',$model->getData('customer_groups'));
                        $collections = Mage::getResourceModel('affiliate/account_collection');
                        $collections->getSelect()
                            ->joinLeft(array('c' => $collections->getTable('customer/entity')),
                                'main_table.customer_id = c.entity_id',
                                array()
                            )->where('FIND_IN_SET(c.group_id, ?)', implode(',', $customerGroups));
                        if ($model->getId()) {
                            $collections->getSelect()
                                ->joinLeft(array('j' => $collections->getTable('affiliatecampaign/joined')),
                                    'main_table.account_id = j.account_id AND j.program_id = ' . $model->getId(),
                                    array()
                                )->where('j.id IS NULL');
                        }
                        $data['program_account'] = $collections->getAllIds();
					}
				}
                if (isset($programAccount) && $programAccount) {
                    if (isset($data['program_account']) && is_array($data['program_account'])) {
                        $data['program_account'] = array_unique(array_merge($programAccount, $data['program_account']));
                    } else {
                        $data['program_account'] = $programAccount;
                    }
				} elseif (isset($data['program_account']) && is_array($data['program_account']) && $model->getId()) {
                    $joinedAccounts = Mage::getResourceModel('affiliatecampaign/account_collection')
                        ->addFieldToFilter('program_id', $model->getId());
                    foreach ($joinedAccounts as $joinedAccount) {
                        $data['program_account'][] = $joinedAccount->getAccountId();
                    }
                    $data['program_account'] = array_unique($data['program_account']);
                }
				
				if (isset($data['program_account']) && is_array($data['program_account']))
					$model->setData('num_account',count($data['program_account']));
				
				$model->save();
				
				// save list of affiliate account
				if (isset($data['program_account']) && is_array($data['program_account'])) {
					Mage::getModel('affiliatecampaign/account')
						->setProgramId($model->getId())
						->setAccountIds($data['program_account'])
						->saveAll();
                    Mage::getModel('affiliatecampaign/joined')->updateJoined($model->getId());
                }
				
				// save list of category
				if (isset($data['category_ids']) && is_string($data['category_ids'])){
					$categoryIds = array_unique(explode(',',$data['category_ids']));
				if (is_array($categoryIds))
					Mage::getModel('affiliatecampaign/category')
						->setProgramId($model->getId())
						->setCategoryIds($categoryIds)
						->setStoreId($storeId)
						->saveAll();
				}
				
				/*/ save list of product
				if (isset($data['program_product']) && is_string($data['program_product'])){
					$programProduct = array();
					parse_str($data['program_product'],$programProduct);
					$data['program_product'] = array_unique(array_keys($programProduct));
				}
				if (isset($data['program_product']) && is_array($data['program_product']))
					Mage::getModel('affiliatecampaign/product')
						->setProgramId($model->getId())
						->setProductIds($data['program_product'])
						->setStoreId($storeId)
						->saveAll();
				*/
				Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('affiliatecampaign')->__('Campaign was successfully saved'));
				Mage::getSingleton('adminhtml/session')->setFormData(false);
				if ($this->getRequest()->getParam('back')) {
					$this->_redirect('*/*/edit', array(
						'id' => $model->getId(),
						'store'	=> $storeId,
					));
					return;
				}
				$this->_redirect('*/*/');
				return;
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
                Mage::getSingleton('adminhtml/session')->setFormData($data);
                $this->_redirect('*/*/edit', array(
                	'id' 	=> $this->getRequest()->getParam('id'),
                	'store'	=> $storeId,
                ));
                return;
            }
        }
        Mage::getSingleton('adminhtml/session')->addError(Mage::helper('affiliatecampaign')->__('Unable to find program to save'));
        $this->_redirect('*/*/');
	}
 
	public function deleteAction() {

		if( $this->getRequest()->getParam('id') > 0 ){
			try {
				$model = Mage::getModel('affiliatecampaign/program');
				$model->setId($this->getRequest()->getParam('id'))
					->delete();
				Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('adminhtml')->__('Campaign was successfully deleted'));
				$this->_redirect('*/*/');
			} catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
				$this->_redirect('*/*/edit', array(
					'id' 	=> $this->getRequest()->getParam('id'),
					'store' => $this->getRequest()->getParam('store'),
				));
			}
		}
		$this->_redirect('*/*/',array('store' => $this->getRequest()->getParam('store')));
	}

    public function massDeleteAction() {

        $affiliatecampaignIds = $this->getRequest()->getParam('affiliatecampaign');
        if(!is_array($affiliatecampaignIds)) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('adminhtml')->__('Please select program(s)'));
        } else {
            try {
                foreach ($affiliatecampaignIds as $affiliatecampaignId) {
                    $affiliatecampaign = Mage::getModel('affiliatecampaign/program')->load($affiliatecampaignId);
                    $affiliatecampaign->delete();
                }
                Mage::getSingleton('adminhtml/session')->addSuccess(
                    Mage::helper('adminhtml')->__(
                        'Total of %d program(s) were successfully deleted', count($affiliatecampaignIds)
                    )
                );
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/index',array('store' => $this->getRequest()->getParam('store')));
    }
	
    public function massStatusAction(){

        $affiliatecampaignIds = $this->getRequest()->getParam('affiliatecampaign');
        if(!is_array($affiliatecampaignIds)){
            Mage::getSingleton('adminhtml/session')->addError($this->__('Please select program(s)'));
        } else {
            try {
                foreach ($affiliatecampaignIds as $affiliatecampaignId) {
                    $affiliatecampaign = Mage::getModel('affiliatecampaign/program')
                        ->setStoreId($this->getRequest()->getParam('store'))
                        ->load($affiliatecampaignId);
                    if ($this->getRequest()->getParam('store')){
	                    foreach ($affiliatecampaign->getStoreAttributes() as $attribute)
	                    	if (!$affiliatecampaign->getData($attribute.'_in_store'))
	                    		$affiliatecampaign->setData($attribute.'_default',true);
	                    $affiliatecampaign->setData('status_default',false);
                    }
                    $affiliatecampaign->setStatus($this->getRequest()->getParam('status'))
                        ->setIsMassupdate(true)
                        ->save();
                }
                $this->_getSession()->addSuccess(
                    $this->__('Total of %d program(s) were successfully updated', count($affiliatecampaignIds))
                );
            } catch (Exception $e) {
                $this->_getSession()->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/index',array('store' => $this->getRequest()->getParam('store')));
    }
  
    public function exportCsvAction(){

        $fileName   = 'affiliatecampaign.csv';
        $content    = $this->getLayout()->createBlock('affiliatecampaign/adminhtml_program_grid')
            ->getCsv();

        $this->_sendUploadResponse($fileName, $content);
    }

    public function exportXmlAction(){

        $fileName   = 'affiliatecampaign.xml';
        $content    = $this->getLayout()->createBlock('affiliatecampaign/adminhtml_program_grid')
            ->getXml();

        $this->_sendUploadResponse($fileName, $content);
    }

    protected function _sendUploadResponse($fileName, $content, $contentType='application/octet-stream')
    {
        $response = $this->getResponse();
        $response->setHeader('HTTP/1.1 200 OK','');
        $response->setHeader('Pragma', 'public', true);
        $response->setHeader('Cache-Control', 'must-revalidate, post-check=0, pre-check=0', true);
        $response->setHeader('Content-Disposition', 'attachment; filename='.$fileName);
        $response->setHeader('Last-Modified', date('r'));
        $response->setHeader('Accept-Ranges', 'bytes');
        $response->setHeader('Content-Length', strlen($content));
        $response->setHeader('Content-type', $contentType);
        $response->setBody($content);
        $response->sendResponse();
        die;
    }
    
    public function programAction(){

    	$this->loadLayout();
		$this->getLayout()->getBlock('account.edit.tab.program')
			->setPrograms($this->getRequest()->getPost('oprogram',null));
		$this->renderLayout();
    }
    
    public function programGridAction(){

    	$this->loadLayout();
		$this->getLayout()->getBlock('account.edit.tab.program')
			->setPrograms($this->getRequest()->getPost('oprogram',null));
		$this->renderLayout();
    }
}