<?php

class Magegiant_Affiliatereport_Block_Statistic extends Mage_Adminhtml_Block_Template
{
    const XML_PATH_ENABLE_CHARTS = 'affiliate/statistic/charts';

    public function __construct()
    {
        parent::__construct();
        $this->setTemplate('magegiant/affiliatereport/statistic.phtml');
    }

    protected function _prepareLayout()
    {
        $this->setChild('sales', $this->getLayout()->createBlock('affiliatereport/sales'));

        if (Mage::getStoreConfig(self::XML_PATH_ENABLE_CHARTS)) {
            $this->setChild('diagrams', $this->getLayout()->createBlock('affiliatereport/diagrams'));
            $this->setChild('left_traffics', $this->getLayout()->createBlock('affiliatereport/left_traffics'));
            $this->setChild('left_commissions', $this->getLayout()->createBlock('affiliatereport/left_transactions'));
        } else {
            $block = $this->getLayout()->createBlock('adminhtml/template')
                ->setTemplate('dashboard/graph/disabled.phtml')
                ->setConfigUrl($this->getUrl('adminhtml/system_config/edit', array('section' => 'affiliate')));
            $this->setChild('diagrams', $block);
            $this->setChild('left_traffics', $this->getLayout()->createBlock('affiliatereport/left_trafficsgrid'));
            $this->setChild('left_commissions', $this->getLayout()->createBlock('affiliatereport/left_transactionsgrid'));
        }

        $this->setChild('totals', $this->getLayout()->createBlock('affiliatereport/diagrams_totals'));

        $this->setChild('grids', $this->getLayout()->createBlock('affiliatereport/grids'));

        parent::_prepareLayout();
    }

    public function getSwitchUrl()
    {
        if ($url = $this->getData('switch_url'))
            return $url;

        return $this->getUrl('*/*/*', array('_current' => true, 'period' => null));
    }
}